"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.parseField = exports.encode = exports["default"] = exports.decode = void 0;
var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));
var _getObjectValue = require("get-object-value");
//@ts-check

var toInt = function toInt(/**@type string*/d) {
  return parseInt(d, 10);
};

/**
 * @param {string} s
 * @returns {[number, string]}
 */
var parseField = exports.parseField = function parseField(s) {
  var iStar = s.indexOf(",");
  var len = toInt(s.substring(0, iStar));
  var val = s.substring(iStar + 1);
  return [len, val];
};

/**
 * @param {string} s
 */
var encode = exports.encode = function encode(s) {
  var _v = JSON.stringify((0, _getObjectValue.toJS)(s));
  var vLen = _v.length;
  var result = vLen + "," + _v;
  return result;
};

/**
 * @param {string} s
 */
var decode = exports.decode = function decode(s) {
  var _parseField = parseField(s),
    vLen = _parseField[0],
    value = _parseField[1];
  return vLen === value.length ? JSON.parse(value) : null;
};
var Storage = /*#__PURE__*/function () {
  /**
   * @param {function} _storage
   * @param {boolean=}  _disableEncode
   */
  function Storage(_storage, _disableEncode) {
    (0, _classCallCheck2["default"])(this, Storage);
    this._storage = _storage;
    this._de = _disableEncode;
  }

  /**
   * @param {string} k
   * @param {any} v
   * @returns {Storage}
   */
  return (0, _createClass2["default"])(Storage, [{
    key: "set",
    value: function set(k, v) {
      var origV = this.get(k);
      if (v !== origV) {
        var s = this._de ? v : encode(v);
        this._storage(k)(s);
        return new Storage(this._storage, this._de);
      } else {
        return this;
      }
    }

    /**
     * @param {object} arr
     * @returns {Storage}
     */
  }, {
    key: "merge",
    value: function merge(arr) {
      var _this = this;
      var nextObj;
      (0, _getObjectValue.forEachMap)(arr,
      /**
       * @param {any} v
       * @param {string} k
       */
      function (v, k) {
        nextObj = _this.set(k, v);
      });
      return nextObj ? nextObj : new Storage(this._storage, this._de);
    }

    /**
     * @param {string} k
     */
  }, {
    key: "get",
    value: function get(k) {
      var s = this._storage(k)();
      if (!s) {
        return;
      }
      return this._de ? s : decode(s);
    }
  }]);
}();
var _default = exports["default"] = Storage;