import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
//@ts-check
import { toJS, forEachMap } from "get-object-value";
var toInt = function toInt(/**@type string*/d) {
  return parseInt(d, 10);
};

/**
 * @param {string} s
 * @returns {[number, string]}
 */
var parseField = function parseField(s) {
  var iStar = s.indexOf(",");
  var len = toInt(s.substring(0, iStar));
  var val = s.substring(iStar + 1);
  return [len, val];
};

/**
 * @param {string} s
 */
var encode = function encode(s) {
  var _v = JSON.stringify(toJS(s));
  var vLen = _v.length;
  var result = vLen + "," + _v;
  return result;
};

/**
 * @param {string} s
 */
var decode = function decode(s) {
  var [vLen, value] = parseField(s);
  return vLen === value.length ? JSON.parse(value) : null;
};
var Storage = /*#__PURE__*/function () {
  /**
   * @param {function} _storage
   * @param {boolean=}  _disableEncode
   */
  function Storage(_storage, _disableEncode) {
    _classCallCheck(this, Storage);
    this._storage = _storage;
    this._de = _disableEncode;
  }

  /**
   * @param {string} k
   * @param {any} v
   * @returns {Storage}
   */
  return _createClass(Storage, [{
    key: "set",
    value: function set(k, v) {
      var origV = this.get(k);
      if (v !== origV) {
        var s = this._de ? v : encode(v);
        this._storage(k)(s);
        return new Storage(this._storage, this._de);
      } else {
        return this;
      }
    }

    /**
     * @param {object} arr
     * @returns {Storage}
     */
  }, {
    key: "merge",
    value: function merge(arr) {
      var _this = this;
      var nextObj;
      forEachMap(arr,
      /**
       * @param {any} v
       * @param {string} k
       */
      function (v, k) {
        nextObj = _this.set(k, v);
      });
      return nextObj ? nextObj : new Storage(this._storage, this._de);
    }

    /**
     * @param {string} k
     */
  }, {
    key: "get",
    value: function get(k) {
      var s = this._storage(k)();
      if (!s) {
        return;
      }
      return this._de ? s : decode(s);
    }
  }]);
}();
export default Storage;
export { parseField, encode, decode };